<template>
  <div>
    <Button @click="exportData" type="primary" style="margin: 0 10px 10px 0;">Экспортировать журнал</Button>
    <b> Примечание: Здесь будет отображаться только журнал ошибок, который был успешно сохранен на сервере.</b>
    <Table ref="table" :columns="columns" :data="errorList"></Table>
  </div>
</template>

<script>
import dayjs from 'dayjs'
import { mapMutations } from 'vuex'

export default {
  name: 'error_logger_page',
  data () {
    return {
      columns: [
        {
          type: 'index',
          title: 'Серийный номер',
          width: 100
        },
        {
          key: 'type',
          title: 'Тип',
          width: 100,
          render: (h, { row }) => {
            return (
              <div>
                <icon size={16} type={row.type === 'ajax' ? 'md-link' : 'md-code-working'}></icon>
              </div>
            )
          }
        },
        {
          key: 'code',
          title: 'Кодировка',
          render: (h, { row }) => {
            return (
              <span>{row.code === 0 ? '-' : row.code}</span>
            )
          }
        },
        {
          key: 'mes',
          title: 'Информация'
        },
        {
          key: 'url',
          title: 'URL'
        },
        {
          key: 'time',
          title: 'Дата/Время',
          render: (h, { row }) => {
            return (
              <span>{dayjs(row.time).format('YYYY-MM-DD HH:mm:ss')}</span>
            )
          },
          sortable: true,
          sortType: 'desc'
        }
      ]
    }
  },
  computed: {
    errorList () {
      return this.$store.state.app.errorList
    }
  },
  methods: {
    ...mapMutations([
      'setHasReadErrorLoggerStatus'
    ]),
    exportData () {
      this.$refs.table.exportCsv({
        filename: 'logs.csv'
      })
    }
  },
  activated () {
    this.setHasReadErrorLoggerStatus()
  },
  mounted () {
    this.setHasReadErrorLoggerStatus()
  }
}
</script>

<style>

</style>
